<template>
  <div class="periods">
    <div class="periods-control">
      <h2 class="periods-title">
        Періоди
      </h2>
      <button class="btn btn-primary" @click="changeDetailView">
        {{toggleText}}
      </button>
      <router-link to="/create" tag="button" class="btn btn-secondary">
        Додати період
      </router-link>
    </div>
    <div class="periods-content">
      <ul class="periods-list" v-if="getPeriods.length">
        <li v-for="item in sortPeriods"
            :key="item.id"
            class="periods-item">
          <PeriodItem :period="item"/>
        </li>
      </ul>
      <div class="periods-empty" v-else>
        <h2 class="empty-text">
          У вас немає жодних записів.<br>
          Створіть новий період натиснувши на кнопку.
        </h2>
        <router-link to="/create" tag="button" class="btn btn-secondary">
          Додати період
        </router-link>
      </div>
    </div>

  </div>
</template>

<script>
  import { mapGetters, mapActions } from 'vuex'
  import PeriodItem from '../PeriodItem/PeriodItem'

  export default {
    name: 'Periods',
    components: { PeriodItem },
    methods: {
      ...mapActions(['changeDetailView'])
    },
    computed: {
      ...mapGetters(['getPeriods', 'getDetailView']),
      sortPeriods () {
        return [...this.getPeriods].reverse()
      },
      toggleText () {
        return this.getDetailView ? 'Коротко' : 'Детально'
      }
    }
  }
</script>

<style lang="scss" scoped>
  @import "../../styles/base/all_base_sheets";

  .periods {
    max-width: $screen-lg;
    @include marginCenter;

    &-control {
      display: flex;
      align-items: center;
      margin-bottom: 40px;
    }

    &-content {
      max-width: $screen-hdready;
      @include marginCenter;
    }

    .btn-primary {
      margin-left: auto;
      margin-right: 20px;
    }

    &-title {
      @include pageTitle;
    }

    &-list {
      display: grid;
      grid-template-columns: 1fr 1fr;
      grid-gap: 40px 40px;
      @include hdready() {
        grid-template-columns: 1fr 1fr 1fr;
      }
    }

    &-item {
      display: flex;
      width: 100%;
    }

    &-empty {
      text-align: center;
      padding: 20vh;
    }

    .empty-text {
      margin-bottom: 40px;
    }
  }
</style>
